component = require('component')
event = require('event')
fs = require('filesystem')
os = require('os')
term = require('term')

holo = component.hologram

function simulate(cells)
  local isnil = false
  return function()
    if isnil then
      return nil
    end
    local newcells = {}
    local cellcount = 0
    for z=15,#cells do
      newcells[z] = {}
      for y=1,#cells[z] do
        newcells[z][y] = {}
        for x=15,#cells[z][y] do
          local adj = 0
          for zo=-1,1 do
            for yo=-1,1 do
              for xo=-1,1 do
                if zo ~= 0 or yo ~= 0 or xo ~= 0 then
                  adj = adj + ((cells[z+zo] and cells[z+zo][y+yo] and cells[z+zo][y+yo][x+xo]) and 1 or 0)
                end
              end
            end
          end
          newcells[z][y][x] = (adj == 2 or (not newcells[z][y][x] and adj == 1) or (not newcells[z][y][x] and adj == 3) or (not newcells[z][y][x] and adj == 4))
          cellcount = cellcount + (newcells[z][y][x] and 1 or 0)
        end
      end
    end
    isnil = cellcount == 0
    cells = newcells
    return cells
  end
end

function renderBoard(cells)
  for z=15,#cells do
    for y=1,#cells[z] do
      for x=15,#cells[z][y] do
        holo.set(x,y,z,cells[z][y][x])
      end
    end
  end
end

holo.clear()
holo.setPaletteColor(1,0x00FF00)

while true do
  local cells = {}
  for z=15,34 do
    cells[z] = {}
    for y=1,18 do
      cells[z][y] = {}
      for x=15,34 do
        cells[z][y][x] = math.random(2) == 1
      end
    end
  end
  for cells in simulate(cells) do
    renderBoard(cells)
    os.sleep()
  end
  os.sleep(10)
end